"use strict";

require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RewardsBlock = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.symbol.description.js");
var _react = _interopRequireWildcard(require("react"));
var _CoalitionSection = require("../CoalitionSection");
var _CoalitionModal = require("..//CoalitionModal");
var _CoalitionCardRewards = require("../CoalitionCardRewards");
var _ = require("..");
var _pngs = require("../../pngs");
var _EmptyBlock = require("./EmptyBlock");
var _CoalitionGtm = require("../CoalitionGtm");
var _utils = require("../../utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
class RewardsBlock extends _react.Component {
  constructor() {
    super(...arguments);
    _defineProperty(this, "state", {
      isShown: false,
      activeCard: null,
      gtmId: this.props.gtmId
    });
    _defineProperty(this, "toggleModal", cardId => {
      this.setState({
        isShown: Boolean(cardId),
        activeCard: this.getCardDetail(cardId)
      });
      this.toggleScrollLock();
    });
    // Allows to close modal with click out of modal
    _defineProperty(this, "onClickOutside", e => this.modal && this.modal.contains(e.target) ? null : this.toggleModal());
    // Allows to close modal with 'Esc'
    _defineProperty(this, "onKeyDown", e => e.keyCode === 27 ? this.toggleModal() : null);
    // Prevents double scroll bar
    _defineProperty(this, "toggleScrollLock", () => document.querySelector("html").classList.toggle("modal-scroll-lock"));
    _defineProperty(this, "getCardDetail", cardId => this.props.rewards.find(reward => reward.id === cardId));
    _defineProperty(this, "showModalFn", (cardId, k, i) => {
      this.toggleModal(cardId, k);
      if (this.state.gtmId) {
        let payload = (0, _CoalitionGtm.event_properties_101_4)();
        payload.reward_id = i.id;
        payload.reward_progress = (0, _utils.rewardsLabel)(i);
        payload.banner_index = i.position;
        (0, _CoalitionGtm.sendTag)(this.state.gtmId, payload);
      }
    });
    _defineProperty(this, "title", "Obtén recompensas");
    _defineProperty(this, "emptyDesc", "Muy pronto podrás llevarte productos de regalo al sumar tus compras");
    _defineProperty(this, "filledDesc", "Llévate productos de regalo al sumar tus compras y llegar a la meta");
    _defineProperty(this, "modalTitle", "Todo sobre tus recompensas");
  }
  render() {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !this.props.rewards || this.props.rewards.length === 0 ? /*#__PURE__*/_react.default.createElement(_EmptyBlock.EmptyBlock, {
      title: this.title,
      description: this.emptyDesc,
      emptyState: _pngs.empty_rewards,
      isBlock: true
    }) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_CoalitionSection.CoalitionSection, {
      title: this.title,
      subtitle: this.filledDesc
    }, this.props.rewards.map((i, k) => /*#__PURE__*/_react.default.createElement(_CoalitionCardRewards.CoalitionCardRewards, {
      key: k,
      id: i.id,
      product: i.image,
      title: i.title,
      used: i.balance,
      needed: i.required_balance,
      availableToRedeem: i.available_to_redeem,
      showModal: (cardId, k) => this.showModalFn(cardId, k, i)
    }))), this.state.isShown ? /*#__PURE__*/_react.default.createElement(_CoalitionModal.CoalitionModal, {
      modalRef: n => this.modal = n,
      closeModal: () => this.toggleModal(),
      onKeyDown: this.onKeyDown,
      onClickOutside: this.onClickOutside,
      title: this.modalTitle
    }, /*#__PURE__*/_react.default.createElement(_.CoalitionCardRewardsDetail, {
      card: this.state.activeCard,
      gtmId: this.props.gtmId
    })) : null));
  }
}
exports.RewardsBlock = RewardsBlock;