"use strict";

require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CoalitionCardStamps = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
var _react = _interopRequireWildcard(require("react"));
var _utils = require("../../utils");
var _pngs = require("../../pngs");
var _CoalitionStampsProgress = require("../CoalitionStampsProgress");
require("./CoalitionCardStamps.scss");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const CoalitionCardStamps = _ref => {
  let {
    id,
    product,
    title,
    used,
    needed,
    availableToRedeem,
    showModal,
    buttonRef
  } = _ref;
  const ready = availableToRedeem > 0 || used >= needed;
  const balanceFixed = ready ? availableToRedeem * needed + used : used;
  const [productImg, solveImg] = (0, _react.useState)();
  (0, _react.useEffect)(() => {
    const testImg = url => {
      let i = new Image();
      i.onload = () => solveImg((0, _utils.getImg)(url));
      i.onerror = () => solveImg((0, _utils.getImg)(_pngs.not_available_vertical));
      i.src = url;
    };
    testImg(product);
  }, [product]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "card-stamps",
    ref: buttonRef,
    onClick: () => showModal(id)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "main"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "product"
  }, productImg), /*#__PURE__*/_react.default.createElement("div", {
    className: "title"
  }, /*#__PURE__*/_react.default.createElement("span", null, (0, _utils.fixContent)(title, 65)))), /*#__PURE__*/_react.default.createElement("div", {
    className: "footer ".concat(ready ? "success" : "")
  }, /*#__PURE__*/_react.default.createElement(_CoalitionStampsProgress.CoalitionStampsProgress, {
    used: balanceFixed,
    needed: needed
  }), /*#__PURE__*/_react.default.createElement("label", null, /*#__PURE__*/_react.default.createElement("b", null, balanceFixed), " de ".concat(needed))));
};
exports.CoalitionCardStamps = CoalitionCardStamps;