"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CoalitionStampsProgressDetail = exports.CoalitionStampsProgress = void 0;
var _react = _interopRequireDefault(require("react"));
var _utils = require("./../../utils");
var _pngs = require("./pngs");
require("./CoalitionStampsProgress.scss");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const CoalitionStampsProgress = _ref => {
  let {
    used = 0,
    needed = 0,
    drawables = 5
  } = _ref;
  const draw = [];
  const limit = needed >= drawables ? drawables : needed;
  for (let i = 0; i < limit; i++) {
    const source = used >= needed ? _pngs.stamp_2 : i < used ? _pngs.stamp_1 : _pngs.stamp_0;
    draw.push( /*#__PURE__*/_react.default.createElement("span", {
      key: (0, _utils.makeId)(5),
      className: "bullet"
    }, /*#__PURE__*/_react.default.createElement("img", {
      src: source,
      alt: "stamp"
    })));
  }
  const remanent = needed - drawables;
  if (remanent <= 0) return draw;
  draw.push( /*#__PURE__*/_react.default.createElement("span", {
    key: (0, _utils.makeId)(5),
    className: "bullet"
  }, /*#__PURE__*/_react.default.createElement("label", {
    className: "simple-counter"
  }, "+".concat(remanent))));
  return draw;
};
exports.CoalitionStampsProgress = CoalitionStampsProgress;
const CoalitionStampsProgressDetail = _ref2 => {
  let {
    used = 0,
    needed = 0,
    drawables = 5
  } = _ref2;
  const draw = [];
  const limit = needed >= drawables ? drawables : needed;
  let counter = 0;
  let filled = 0;
  let remanent = 0;
  const fillBullets = (limit, src) => {
    for (let i = 0; i < limit; i++) {
      draw.push( /*#__PURE__*/_react.default.createElement("span", {
        key: (0, _utils.makeId)(5),
        className: "bullet"
      }, (0, _utils.getImg)(src, "stamp")));
    }
  };
  if (used >= needed) {
    counter = needed - limit;
    remanent = 0;
    filled = limit;
  } else if (used === 0) {
    counter = needed - limit;
    remanent = limit;
    filled = 0;
  } else {
    counter = needed - limit;
    const helper = needed - used;
    remanent = helper >= limit ? limit : helper;
    filled = limit - remanent;
  }
  if (counter) {
    const src = used === 0 ? _pngs.stampBig_3 : used < needed ? _pngs.stampBig_4 : _pngs.stampBig_5;
    draw.push( /*#__PURE__*/_react.default.createElement("span", {
      key: (0, _utils.makeId)(5),
      className: "bullet-counter",
      style: {
        backgroundImage: "url(".concat(src, ")")
      }
    }, /*#__PURE__*/_react.default.createElement("label", null, "+".concat(counter))));
  }
  fillBullets(filled, used < needed ? _pngs.stampBig_1 : _pngs.stampBig_2);
  fillBullets(remanent, _pngs.stampBig_0);
  return draw;
};
exports.CoalitionStampsProgressDetail = CoalitionStampsProgressDetail;