"use strict";

require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExtraPointsPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.symbol.description.js");
var _react = _interopRequireWildcard(require("react"));
var _components = require("../components");
var _utils = require("../utils");
var _pngs = require("../pngs");
var _CoalitionGtm = require("../components/CoalitionGtm");
require("./../components/CoalitionBlocks/EmptyBlock.scss");
require("./Pages.scss");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
class ExtraPointsPage extends _react.Component {
  constructor() {
    super(...arguments);
    _defineProperty(this, "state", {
      isShown: false,
      activeCard: null,
      gtmId: this.props.gtmId
    });
    _defineProperty(this, "toggleModal", cardId => {
      this.setState({
        isShown: Boolean(cardId),
        activeCard: this.getCardDetail(cardId)
      });
      this.toggleScrollLock();
    });
    // Allows to close modal with click out of modal
    _defineProperty(this, "onClickOutside", e => this.modal && this.modal.contains(e.target) ? null : this.toggleModal());
    // Allows to close modal with 'Esc'
    _defineProperty(this, "onKeyDown", e => e.keyCode === 27 ? this.toggleModal() : null);
    // Prevents double scroll bar
    _defineProperty(this, "toggleScrollLock", () => document.querySelector("html").classList.toggle("modal-scroll-lock"));
    _defineProperty(this, "getCardDetail", cardId => this.props.extraPoints.find(extra => extra.id === cardId));
    _defineProperty(this, "PageButton", () => /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
      label: "Volver al Inicio",
      klass: "coalition-button-go-dashboard",
      onClickEvent: this.props.buttonClicked
    }));
    _defineProperty(this, "NavButton", () => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
      label: this.title,
      klass: "nav-button",
      onClickEvent: this.props.buttonClicked
    }, (0, _utils.getImg)(_pngs.chevron_left, "back-icon"))));
    _defineProperty(this, "emptyTitle", "Gana puntos adicionales");
    _defineProperty(this, "emptyDesc", "Muy pronto podrás ganar más puntos en el total de tu compra");
    _defineProperty(this, "title", "Puntos adicionales");
    _defineProperty(this, "modalTitle", "Todo sobre tus ".concat(this.title));
    _defineProperty(this, "filledDesc", "Gana más puntos en el total de tu compra al elegir productos participantes");
  }
  componentDidMount() {
    if (this.state.gtmId) {
      (0, _CoalitionGtm.sendTag)(this.state.gtmId, (0, _CoalitionGtm.event_properties_103_1)());
    }
  }
  render() {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !this.props.extraPoints || this.props.extraPoints.length === 0 ? /*#__PURE__*/_react.default.createElement(_components.EmptyBlock, {
      title: this.emptyTitle,
      description: this.emptyDesc,
      emptyState: _pngs.empty_extras,
      children: /*#__PURE__*/_react.default.createElement(this.PageButton, null)
    }) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      className: "carousel-cards"
    }, /*#__PURE__*/_react.default.createElement(this.NavButton, null), /*#__PURE__*/_react.default.createElement("div", {
      className: "title"
    }, this.emptyTitle), /*#__PURE__*/_react.default.createElement("div", {
      className: "description"
    }, this.filledDesc), this.props.extraPoints.map((i, k) => /*#__PURE__*/_react.default.createElement(_components.CoalitionCardExtras, {
      key: k,
      id: i.id,
      product: i.image,
      title: i.title,
      expiracy: i.valid_until,
      extraPoints: i.extra_points,
      showModal: cardId => {
        if (this.state.gtmId) {
          let payload1 = (0, _CoalitionGtm.event_properties_103_2)();
          payload1.extra_points_id = i.id;
          payload1.partner = i.sponsor_name;
          payload1.click_id = null;
          (0, _CoalitionGtm.sendTag)(this.state.gtmId, payload1);
          let payload2 = (0, _CoalitionGtm.event_properties_103_3)();
          payload2.extra_points_id = i.id;
          payload2.partner = i.sponsor_name;
          (0, _CoalitionGtm.sendTag)(this.state.gtmId, payload2);
        }
        this.toggleModal(cardId);
      },
      fromPage: true
    }))), this.state.isShown ? /*#__PURE__*/_react.default.createElement(_components.CoalitionModal, {
      modalRef: n => this.modal = n,
      closeModal: () => this.toggleModal(),
      onKeyDown: this.onKeyDown,
      onClickOutside: this.onClickOutside,
      title: this.modalTitle
    }, /*#__PURE__*/_react.default.createElement(_components.CoalitionCardExtrasDetail, {
      card: this.state.activeCard,
      gtmId: this.props.gtmId
    })) : null));
  }
}
exports.ExtraPointsPage = ExtraPointsPage;