"use strict";

require("core-js/modules/es.object.assign.js");
require("core-js/modules/es.weak-map.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MovementsPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.array.sort.js");
var _react = _interopRequireWildcard(require("react"));
var _utils = require("../utils");
var _pngs = require("../pngs");
var _components = require("../components");
require("./Pages.scss");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const MovementsPage = _ref => {
  let {
    movements = [],
    buttonClicked
  } = _ref;
  const [movs, setMovs] = (0, _react.useState)();
  (0, _react.useEffect)(() => {
    const buildMovements = () => {
      const movsToDrawFiltered = movements.filter(mov => mov.data.length > 0);
      if (!movsToDrawFiltered || movsToDrawFiltered.length === 0) return;
      // eslint-disable-next-line array-callback-return
      movsToDrawFiltered.map(block => {
        block.data.sort((a, b) => new Date(b.transaction_date) - new Date(a.transaction_date));
      });
      const movsAsHtml = movsToDrawFiltered.map((movement, k) => /*#__PURE__*/_react.default.createElement(MovementsCard, _extends({
        key: k
      }, movement)));
      setMovs(movsAsHtml);
    };
    buildMovements();
  }, [movements]);
  const title = "Movimientos de tus puntos";
  const emptyDesc = "Comienza a usar tu programa de lealtad para ganar puntos";
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "movements-page"
  }, !movements || movements.length === 0 ? /*#__PURE__*/_react.default.createElement("div", {
    className: "no-content"
  }, /*#__PURE__*/_react.default.createElement(_components.EmptyBlock, {
    title: title,
    description: emptyDesc,
    emptyState: _pngs.empty_movements
  }, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
    label: "Volver al Inicio",
    klass: "coalition-button-go-dashboard",
    onClickEvent: buttonClicked
  }))) : /*#__PURE__*/_react.default.createElement("div", {
    className: "page-content"
  }, /*#__PURE__*/_react.default.createElement(_components.CoalitionButton, {
    label: title,
    klass: "nav-button",
    onClickEvent: buttonClicked
  }, (0, _utils.getImg)(_pngs.chevron_left, "back-icon")), /*#__PURE__*/_react.default.createElement("div", {
    className: "movements"
  }, movs))));
};
exports.MovementsPage = MovementsPage;
const MovementsCard = _ref2 => {
  let {
    title,
    data
  } = _ref2;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-card"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "date"
  }, Titlelize(title)), data.map((info, i) => /*#__PURE__*/_react.default.createElement(MovementRow, _extends({
    key: i
  }, info))));
};
const MovementRow = _ref3 => {
  let {
    location_name,
    brand_image,
    bits,
    is_accrual,
    transaction_date
  } = _ref3;
  const formattedDate = new Date(transaction_date).toLocaleDateString("es-mx", {
    weekday: "long",
    day: "numeric"
  });
  const [movImg, solveImg] = (0, _react.useState)();
  (0, _react.useEffect)(() => {
    const testImgDesktop = url => {
      let i = new Image();
      i.onload = () => solveImg((0, _utils.getImg)(url));
      i.onerror = () => solveImg((0, _utils.getImg)(_pngs.not_img));
      i.src = url;
    };
    testImgDesktop(brand_image);
  }, [brand_image]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "movement-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "container-logo"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "logo"
  }, movImg)), /*#__PURE__*/_react.default.createElement("div", {
    className: "container-description"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "description"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "title"
  }, location_name), /*#__PURE__*/_react.default.createElement("div", {
    className: "detail"
  }, Titlelize(formattedDate)))), /*#__PURE__*/_react.default.createElement("div", {
    className: "container-ammount"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "ammount"
  }, /*#__PURE__*/_react.default.createElement("label", null, is_accrual ? "+ " : "- ", /*#__PURE__*/_react.default.createElement(_utils.MakePriceWithCents, {
    bits: bits
  }))))));
};
const Titlelize = str => str.charAt(0).toUpperCase() + str.slice(1);